Open bus test
=============
This NES program tests the behavior of an NES emulator, famiclone,
or flash card when the CPU accesses "open bus", or memory that isn't
mapped to anything.  It produces 16 bytes of data to characterize
how a particular combination of console and cartridge handles such
accesses.

Rationale
---------
I was writing controller detection routines, but I hit a snag: the
FCEUX emulator, Mednafen emulator, and the PowerPak disagree on what
value is returned for "open bus".  The Mindscape bug is alive and
well.  See docs/methodology.md for what I was trying to do.

Expected results
----------------
With a modded donor cart or an EverDrive N8 on an authentic NES,
you'll get something like this:

    PPU readback
         00 FF 00 FF 00 FF 00 FF
    PPU latch     20 3F 3F 3F 3F
    APU open bus        40 40 3F
    
    Empty port       40 20 40 20
    Controller       40 20 41 21
    SNES Mouse       40 20 41 21
    Four Score       40 20 41 21
    Zapper           48 28 48 28
    Power Pad        40 20 58 38
    Arkanoid         40 20 50 30

The PowerPak has pull-ups on the data lines, which turn any bit not
being driven to 0 into a 1:

    PPU readback
         00 FF 00 FF 00 FF FF FF
    PPU latch     20 3F 3F 3F 3F
    APU open bus        FF FF FF

And all controller results from a PowerPak will be OR'd with $E0.

Let me know what you get.  My nick on the [EFnet] IRC network is
tepples and I'm often seen in the #nesdev channel.  There is also a
topic for this test on NESdev BBS, titled [Riding the open bus].

[EFnet]: http://www.efnet.org/
[Riding the open bus]: http://forums.nesdev.com/viewtopic.php?f=2&t=12549

Legal
-----
The test program is distributed under the following terms:

    Copyright 2016 Damian Yerrick
    Copying and distribution of this file, with or without
    modification, are permitted in any medium without royalty
    provided the copyright notice and this notice are preserved.
    This file is offered as-is, without any warranty.
