.ifndef GLOBAL_INC
.define GLOBAL_INC

; init.s
.global reset_handler

; main.s
.global main, nmi_handler, irq_handler, press_A
.global OAM
.globalzp cur_keys, new_keys, oam_used, nmis

; lowlevel.s
.global lowlevel_display

; padgfx.s
.global load_controller_tiles, load_controller_palette
.global draw_one_controller, load_frame_tiles

; padnames.s
; order must correspond to tilesets/controllerimages.png
TYPE_NES_PAD = 0
TYPE_NES_DOGBONE = 1
TYPE_FC_1P = 2
TYPE_FC_2P = 3
TYPE_FOUR_SCORE = 4
TYPE_ZAPPER = 5
TYPE_NES_ARKANOID = 6
TYPE_POWER_PAD = 7
TYPE_SNES_PAD = 8
TYPE_SNES_MOUSE = 9
NUM_PADNAMES = 10

.global draw_controller_name, draw_controller_bits

; bg.s
.global load_font, puts_16, puts_multiline_16, puts_multiline_16_01
.global cls_puts_multiline
.global seek_nt_line_y, seek_nt_line_a
.global hexdump8, hexdump8_02

; ppuclear.s
.global ppu_clear_nt, ppu_clear_oam, ppu_screen_on

; pads.s
.global read_pads

; identify.s
.global ident_count, ident_type, ident_bits
.global one_shl_x
.global identify_controllers

; openbus.s
.globalzp cbits_p1, cbits_p2
.globalzp min4016, max4016, min3F16, min4017, max4017, min3F17
.global ppu_readback_values, ppu_latchtest_values, open_bus_values
.global ensure_open_bus_ok, detect_controller_wires, wait36k

; unpb53.s
.globalzp ciSrc, ciDst
.global PB53_outbuf
.global unpb53_xtiles

.endif
